<template>
  <div class="card-app card shadow" :class="{ active: isActive }">
    <div class="card-body row g-0">
      <SvgYouTube class="icon-app" :showLabel="false" :showIcon="true" />
      <SvgYouTube class="label-app" :showLabel="true" :showIcon="false" />
      <!-- <div class="text-muted mt-3">Biggest online video sharing and social media platform.</div> -->
      <div class="label-user text-muted">{{ displayName }}</div>
      <button
        class="btn btn-connect"
        :class="[isActive ? 'btn-success' : 'btn-primary']"
        @click="OnBtnConnectClicked"
      ></button>
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import SvgYouTube from "./SvgYouTube.vue";
import PLATFORMS from "../enums/platforms";

export default {
  components: { SvgYouTube },
  props: ["userName"],
  computed: {
    profiles() {
      return this.$store.state.profiles.list.filter(
        (p) => p.platform === PLATFORMS.YOUTUBE
      );
    },
    isActive() {
      return this.profiles.length > 0;
    },
    displayName() {
      return this.profiles[0] ? this.profiles[0].displayName : "";
    },
  },
  methods: {
    ...mapActions(["disconnectProfile"]),
    async OnBtnConnectClicked() {
      //connect
      if (!this.isActive)
        window.location.href = `${process.env.VUE_APP_API_URL}/youtube/connect?redirect_to=${window.location.origin}/Account`;
      //disconnect
      else
        await this.disconnectProfile(this.profiles[0].id);
    },
  },
};
</script>
